<template>
  <div id="app">
    <ButtonStart playText="Start" v-on:click="play"/>
    <p>{{ level }}</p>
    <ButtonSimon
      v-for="button in mapCouleur"
      v-bind:key="button.color"
      v-bind:button="button"
      v-on:click="clickButton(button.color)"
    ></ButtonSimon>
  </div>
</template>

<script>
import ButtonStart from "../components/buttonStartComponent.vue";
import ButtonSimon from "../components/buttonSimonComponent.vue";

export default {
  name: "App",
  components: {
    ButtonStart,
    ButtonSimon
  },
  data: () => {
    return {
      level: "Level 0",
      suiteCouleur: [],
      mapCouleur: [
        {
          color: "bleu",
          backgroundColor: "blue",
          actif: false,
        },
        { color: "rouge", backgroundColor: "red", actif: false },
        {
          color: "jaune",
          backgroundColor: "yellow",
          actif: false,
        },
        {
          color: "vert",
          backgroundColor: "green",
          actif: false,
        },
      ],
      caseCocher: 0,
      countLevel: 0,
    };
  },
  methods: {
    resetColor: function () {
      for (var i = 0; i < this.mapCouleur.length; i++) {
        this.mapCouleur[i].actif = false;
      }
    },
    play: function () {
      this.suiteCouleur = [];
      this.resetColor();
      this.playLevel();
      this.caseCocher = 0;
    },
    clickButton: function (couleur) {
      if (this.countLevel != 0) {
        this.selectCouleur(couleur);
        if (couleur == this.suiteCouleur[this.caseCocher]) {
          setTimeout(() => {
            this.resetColor();
          }, 400);
          this.caseCocher++;
          if (this.suiteCouleur.length == this.caseCocher) {
            setTimeout(() => {
              this.playLevel();
              this.caseCocher = 0;
            }, 1000);
          }
        } else {
          alert("perdu");
          this.loose();
        }
      } else {
        alert("Veuillez lancer la partie pour jouer");
      }
    },
    ajouterNouvelleCouleurAleatoirement: function () {
      this.suiteCouleur.push(
        this.mapCouleur[Math.floor(Math.random() * 4)].color
      );
    },
    playLevel: function () {
      this.countLevel++;
      this.level = "Level " + this.countLevel;
      this.ajouterNouvelleCouleurAleatoirement();
      this.affichageCouleur();
    },
    affichageCouleur: function () {
      for (var i = 0; i < this.countLevel; i++) {
        let id = i;
        console.log(this.suiteCouleur[i]);
        setTimeout(() => {
          this.selectCouleur(this.suiteCouleur[id]);
        }, i * 800);
      }
    },
    selectCouleur: function (couleur) {
      for (var i = 0; i < this.mapCouleur.length; i++) {
        if (this.mapCouleur[i].color == couleur) {
          this.mapCouleur[i].actif = true;
        }
      }

      setTimeout(() => {
        this.resetColor();
      }, 200);
    },
    loose: function () {
      this.suiteCouleur = [];
      this.resetColor();
      this.caseCocher = 0;
      this.countLevel = 0;
      this.level = "Level " + this.countLevel;
    },
  },
};
</script>
